Ipopt 3.12.10

- Main Page
- Classes
- Files

- Class List
- Class Index
- Class Hierarchy
- Class Members

All Classes Namespaces Files Functions Variables Typedefs Enumerations Enumerator Friends Macros
Public Member Functions | Private Member Functions | Private Attributes | List of all members
Ipopt::StdAugSystemSolver Class Reference

Solver for the augmented system for triple type matrices. More...

`#include <IpStdAugSystemSolver.hpp>`

Inheritance diagram for Ipopt::StdAugSystemSolver:
[legend]

## Public Member Functions
bool | InitializeImpl (const OptionsList &options, const std::string &prefix)
| overloaded from AlgorithmStrategyObject More...
virtual ESymSolverStatus | MultiSolve (const SymMatrix *W, double W_factor, const Vector *D_x, double delta_x, const Vector *D_s, double delta_s, const Matrix *J_c, const Vector *D_c, double delta_c, const Matrix *J_d, const Vector *D_d, double delta_d, std::vector< SmartPtr< const Vector > > &rhs_xV, std::vector< SmartPtr< const Vector > > &rhs_sV, std::vector< SmartPtr< const Vector > > &rhs_cV, std::vector< SmartPtr< const Vector > > &rhs_dV, std::vector< SmartPtr< Vector > > &sol_xV, std::vector< SmartPtr< Vector > > &sol_sV, std::vector< SmartPtr< Vector > > &sol_cV, std::vector< SmartPtr< Vector > > &sol_dV, bool check_NegEVals, Index numberOfNegEVals)
| Set up the augmented system and solve it for a set of given right hand side - implementation for GenTMatrices and SymTMatrices. More...
virtual Index | NumberOfNegEVals () const
| Number of negative eigenvalues detected during last solve. More...
virtual bool | ProvidesInertia () const
| Query whether inertia is computed by linear solver. More...
virtual bool | IncreaseQuality ()
| Request to increase quality of solution for next solve. More...
Constructors/Destructors
| StdAugSystemSolver (SymLinearSolver &LinSolver)
| Constructor using only a linear solver object. More...
virtual | ~StdAugSystemSolver ()
| Default destructor. More...
Public Member Functions inherited from Ipopt::AugSystemSolver
virtual ESymSolverStatus | Solve (const SymMatrix *W, double W_factor, const Vector *D_x, double delta_x, const Vector *D_s, double delta_s, const Matrix *J_c, const Vector *D_c, double delta_c, const Matrix *J_d, const Vector *D_d, double delta_d, const Vector &rhs_x, const Vector &rhs_s, const Vector &rhs_c, const Vector &rhs_d, Vector &sol_x, Vector &sol_s, Vector &sol_c, Vector &sol_d, bool check_NegEVals, Index numberOfNegEVals)
| Set up the augmented system and solve it for a given right hand side. More...
| AugSystemSolver ()
| Default constructor. More...
virtual | ~AugSystemSolver ()
| Default destructor. More...
Public Member Functions inherited from Ipopt::AlgorithmStrategyObject
bool | Initialize (const Journalist &jnlst, IpoptNLP &ip_nlp, IpoptData &ip_data, IpoptCalculatedQuantities &ip_cq, const OptionsList &options, const std::string &prefix)
| This method is called every time the algorithm starts again - it is used to reset any internal state. More...
bool | ReducedInitialize (const Journalist &jnlst, const OptionsList &options, const std::string &prefix)
| Reduced version of the Initialize method, which does not require special Ipopt information. More...
| AlgorithmStrategyObject ()
| Default Constructor. More...
virtual | ~AlgorithmStrategyObject ()
| Default Destructor. More...
Public Member Functions inherited from Ipopt::ReferencedObject
| ReferencedObject ()
virtual | ~ReferencedObject ()
Index | ReferenceCount () const
void | AddRef (const Referencer *referencer) const
void | ReleaseRef (const Referencer *referencer) const

## Private Member Functions
void | CreateAugmentedSpace (const SymMatrix &W, const Matrix &J_c, const Matrix &J_d, const Vector &proto_x, const Vector &proto_s, const Vector &proto_c, const Vector &proto_d)
| Create the matrix space for the Compound Sym Matrix that represents the augmented system. More...
void | CreateAugmentedSystem (const SymMatrix *W, double W_factor, const Vector *D_x, double delta_x, const Vector *D_s, double delta_s, const Matrix &J_c, const Vector *D_c, double delta_c, const Matrix &J_d, const Vector *D_d, double delta_d, const Vector &proto_x, const Vector &proto_s, const Vector &proto_c, const Vector &proto_d)
| Create the new compound sym matrix that represents the augmented system. More...
bool | AugmentedSystemRequiresChange (const SymMatrix *W, double W_factor, const Vector *D_x, double delta_x, const Vector *D_s, double delta_s, const Matrix &J_c, const Vector *D_c, double delta_c, const Matrix &J_d, const Vector *D_d, double delta_d)
| Check the internal tags and decide if the passed variables are different from what is in the augmented_system_. More...
Default Compiler Generated Methods
(Hidden to avoid implicit creation/calling). These methods are not implemented and we do not want the compiler to implement them for us, so we declare them private and do not define them. This ensures that they will not be implicitly created/called.
| StdAugSystemSolver ()
| Default constructor. More...
| StdAugSystemSolver (const StdAugSystemSolver &)
| Copy Constructor. More...
void | operator= (const StdAugSystemSolver &)
| Overloaded Equals Operator. More...

## Private Attributes
SmartPtr< SymLinearSolver > | linsolver_
| The linear solver object that is to be used to solve the linear systems. More...
SmartPtr< CompoundSymMatrixSpace > | augmented_system_space_
| Spaces for piecing together the augmented system. More...
SmartPtr< SumSymMatrixSpace > | sumsym_space_x_
SmartPtr< DiagMatrixSpace > | diag_space_x_
SmartPtr< DiagMatrixSpace > | diag_space_s_
SmartPtr< DiagMatrixSpace > | diag_space_c_
SmartPtr< IdentityMatrixSpace > | ident_space_ds_
SmartPtr< DiagMatrixSpace > | diag_space_d_
SmartPtr< CompoundVectorSpace > | augmented_vector_space_
SmartPtr< CompoundSymMatrix > | augmented_system_
| The resulting augmented matrix. More...
SmartPtr< const SymMatrix > | old_w_
| A copy of a previous W used in the augmented_system_. More...
Tags and values to track in order to decide whether the
matrix has to be updated compared to the most recent call of the Set method.
TaggedObject::Tag | w_tag_
| Tag for W matrix. More...
double | w_factor_
| Most recent value of W_factor. More...
TaggedObject::Tag | d_x_tag_
| Tag for D_x vector, representing the diagonal matrix D_x. More...
double | delta_x_
| Most recent value of delta_x from Set method. More...
TaggedObject::Tag | d_s_tag_
| Tag for D_s vector, representing the diagonal matrix D_s. More...
double | delta_s_
| Most recent value of delta_s from Set method. More...
TaggedObject::Tag | j_c_tag_
| Tag for J_c matrix. More...
TaggedObject::Tag | d_c_tag_
| Tag for D_c vector, representing the diagonal matrix D_c. More...
double | delta_c_
| Most recent value of delta_c from Set method. More...
TaggedObject::Tag | j_d_tag_
| Tag for J_d matrix. More...
TaggedObject::Tag | d_d_tag_
| Tag for D_d vector, representing the diagonal matrix D_d. More...
double | delta_d_
| Most recent value of delta_d from Set method. More...
TaggedObject::Tag | augsys_tag_
| This is the tag of the matrix storing the augmented system. More...
Algorithmic parameters
bool | warm_start_same_structure_
| Flag indicating whether the TNLP with identical structure has already been solved before. More...

## Additional Inherited Members
Protected Member Functions inherited from Ipopt::AlgorithmStrategyObject
const Journalist & | Jnlst () const
IpoptNLP & | IpNLP () const
IpoptData & | IpData () const
IpoptCalculatedQuantities & | IpCq () const
bool | HaveIpData () const

## Detailed Description

Solver for the augmented system for triple type matrices.

The current implemetation assumes that all matrices are of the type SymTMatrix, and all vectors are of the type DenseVector.

Definition at line 27 of file IpStdAugSystemSolver.hpp.

## Constructor & Destructor Documentation

Ipopt::StdAugSystemSolver::StdAugSystemSolver | ( | SymLinearSolver & | LinSolver | ) |

Constructor using only a linear solver object.

virtual Ipopt::StdAugSystemSolver::~StdAugSystemSolver | ( |  | ) |
| virtual

Default destructor.

Ipopt::StdAugSystemSolver::StdAugSystemSolver | ( |  | ) |
| private

Default constructor.

Ipopt::StdAugSystemSolver::StdAugSystemSolver | ( | const StdAugSystemSolver & |  | ) |
| private

Copy Constructor.

## Member Function Documentation

bool Ipopt::StdAugSystemSolver::InitializeImpl | ( | const OptionsList & | options,
|  | const std::string & | prefix
| ) |  |
| virtual

overloaded from AlgorithmStrategyObject

Implements Ipopt::AugSystemSolver.

virtual ESymSolverStatus Ipopt::StdAugSystemSolver::MultiSolve | ( | const SymMatrix * | W,
|  | double | W_factor,
|  | const Vector * | D_x,
|  | double | delta_x,
|  | const Vector * | D_s,
|  | double | delta_s,
|  | const Matrix * | J_c,
|  | const Vector * | D_c,
|  | double | delta_c,
|  | const Matrix * | J_d,
|  | const Vector * | D_d,
|  | double | delta_d,
|  | std::vector< SmartPtr< const Vector > > & | rhs_xV,
|  | std::vector< SmartPtr< const Vector > > & | rhs_sV,
|  | std::vector< SmartPtr< const Vector > > & | rhs_cV,
|  | std::vector< SmartPtr< const Vector > > & | rhs_dV,
|  | std::vector< SmartPtr< Vector > > & | sol_xV,
|  | std::vector< SmartPtr< Vector > > & | sol_sV,
|  | std::vector< SmartPtr< Vector > > & | sol_cV,
|  | std::vector< SmartPtr< Vector > > & | sol_dV,
|  | bool | check_NegEVals,
|  | Index | numberOfNegEVals
| ) |  |
| virtual

Set up the augmented system and solve it for a set of given right hand side - implementation for GenTMatrices and SymTMatrices.

Reimplemented from Ipopt::AugSystemSolver.

virtual Index Ipopt::StdAugSystemSolver::NumberOfNegEVals | ( |  | ) | const
| virtual

Number of negative eigenvalues detected during last solve.

Returns the number of negative eigenvalues of the most recent factorized matrix. This must not be called if the linear solver does not compute this quantities (see ProvidesInertia).

Implements Ipopt::AugSystemSolver.

virtual bool Ipopt::StdAugSystemSolver::ProvidesInertia | ( |  | ) | const
| virtual

Query whether inertia is computed by linear solver.

Returns true, if linear solver provides inertia.

Implements Ipopt::AugSystemSolver.

virtual bool Ipopt::StdAugSystemSolver::IncreaseQuality | ( |  | ) |
| virtual

Request to increase quality of solution for next solve.

Ask underlying linear solver to increase quality of solution for the next solve (e.g. increase pivot tolerance). Returns false, if this is not possible (e.g. maximal pivot tolerance already used.)

Implements Ipopt::AugSystemSolver.

void Ipopt::StdAugSystemSolver::operator= | ( | const StdAugSystemSolver & |  | ) |
| private

Overloaded Equals Operator.

void Ipopt::StdAugSystemSolver::CreateAugmentedSpace | ( | const SymMatrix & | W,
|  | const Matrix & | J_c,
|  | const Matrix & | J_d,
|  | const Vector & | proto_x,
|  | const Vector & | proto_s,
|  | const Vector & | proto_c,
|  | const Vector & | proto_d
| ) |  |
| private

Create the matrix space for the Compound Sym Matrix that represents the augmented system.

This signifies the "first" time through and requires all structural knowledge

void Ipopt::StdAugSystemSolver::CreateAugmentedSystem | ( | const SymMatrix * | W,
|  | double | W_factor,
|  | const Vector * | D_x,
|  | double | delta_x,
|  | const Vector * | D_s,
|  | double | delta_s,
|  | const Matrix & | J_c,
|  | const Vector * | D_c,
|  | double | delta_c,
|  | const Matrix & | J_d,
|  | const Vector * | D_d,
|  | double | delta_d,
|  | const Vector & | proto_x,
|  | const Vector & | proto_s,
|  | const Vector & | proto_c,
|  | const Vector & | proto_d
| ) |  |
| private

Create the new compound sym matrix that represents the augmented system.

This is done EVERY time Solve is called with ANY different information

bool Ipopt::StdAugSystemSolver::AugmentedSystemRequiresChange | ( | const SymMatrix * | W,
|  | double | W_factor,
|  | const Vector * | D_x,
|  | double | delta_x,
|  | const Vector * | D_s,
|  | double | delta_s,
|  | const Matrix & | J_c,
|  | const Vector * | D_c,
|  | double | delta_c,
|  | const Matrix & | J_d,
|  | const Vector * | D_d,
|  | double | delta_d
| ) |  |
| private

Check the internal tags and decide if the passed variables are different from what is in the augmented_system_.

## Member Data Documentation

SmartPtr<SymLinearSolver> Ipopt::StdAugSystemSolver::linsolver_
| private

The linear solver object that is to be used to solve the linear systems.

Definition at line 161 of file IpStdAugSystemSolver.hpp.

SmartPtr<CompoundSymMatrixSpace> Ipopt::StdAugSystemSolver::augmented_system_space_
| private

Spaces for piecing together the augmented system.

Definition at line 164 of file IpStdAugSystemSolver.hpp.

SmartPtr<SumSymMatrixSpace> Ipopt::StdAugSystemSolver::sumsym_space_x_
| private

Definition at line 165 of file IpStdAugSystemSolver.hpp.

SmartPtr<DiagMatrixSpace> Ipopt::StdAugSystemSolver::diag_space_x_
| private

Definition at line 166 of file IpStdAugSystemSolver.hpp.

SmartPtr<DiagMatrixSpace> Ipopt::StdAugSystemSolver::diag_space_s_
| private

Definition at line 167 of file IpStdAugSystemSolver.hpp.

SmartPtr<DiagMatrixSpace> Ipopt::StdAugSystemSolver::diag_space_c_
| private

Definition at line 168 of file IpStdAugSystemSolver.hpp.

SmartPtr<IdentityMatrixSpace> Ipopt::StdAugSystemSolver::ident_space_ds_
| private

Definition at line 169 of file IpStdAugSystemSolver.hpp.

SmartPtr<DiagMatrixSpace> Ipopt::StdAugSystemSolver::diag_space_d_
| private

Definition at line 170 of file IpStdAugSystemSolver.hpp.

SmartPtr<CompoundVectorSpace> Ipopt::StdAugSystemSolver::augmented_vector_space_
| private

Definition at line 172 of file IpStdAugSystemSolver.hpp.

TaggedObject::Tag Ipopt::StdAugSystemSolver::w_tag_
| private

Tag for W matrix.

If W has been given to Set as NULL, then this tag is set to 0

Definition at line 182 of file IpStdAugSystemSolver.hpp.

double Ipopt::StdAugSystemSolver::w_factor_
| private

Most recent value of W_factor.

Definition at line 184 of file IpStdAugSystemSolver.hpp.

TaggedObject::Tag Ipopt::StdAugSystemSolver::d_x_tag_
| private

Tag for D_x vector, representing the diagonal matrix D_x.

If D_x has been given to Set as NULL, then this tag is set to 0

Definition at line 188 of file IpStdAugSystemSolver.hpp.

double Ipopt::StdAugSystemSolver::delta_x_
| private

Most recent value of delta_x from Set method.

Definition at line 190 of file IpStdAugSystemSolver.hpp.

TaggedObject::Tag Ipopt::StdAugSystemSolver::d_s_tag_
| private

Tag for D_s vector, representing the diagonal matrix D_s.

If D_s has been given to Set as NULL, then this tag is set to 0

Definition at line 194 of file IpStdAugSystemSolver.hpp.

double Ipopt::StdAugSystemSolver::delta_s_
| private

Most recent value of delta_s from Set method.

Definition at line 196 of file IpStdAugSystemSolver.hpp.

TaggedObject::Tag Ipopt::StdAugSystemSolver::j_c_tag_
| private

Tag for J_c matrix.

If J_c has been given to Set as NULL, then this tag is set to 0

Definition at line 200 of file IpStdAugSystemSolver.hpp.

TaggedObject::Tag Ipopt::StdAugSystemSolver::d_c_tag_
| private

Tag for D_c vector, representing the diagonal matrix D_c.

If D_c has been given to Set as NULL, then this tag is set to 0

Definition at line 204 of file IpStdAugSystemSolver.hpp.

double Ipopt::StdAugSystemSolver::delta_c_
| private

Most recent value of delta_c from Set method.

Definition at line 206 of file IpStdAugSystemSolver.hpp.

TaggedObject::Tag Ipopt::StdAugSystemSolver::j_d_tag_
| private

Tag for J_d matrix.

If J_d has been given to Set as NULL, then this tag is set to 0

Definition at line 210 of file IpStdAugSystemSolver.hpp.

TaggedObject::Tag Ipopt::StdAugSystemSolver::d_d_tag_
| private

Tag for D_d vector, representing the diagonal matrix D_d.

If D_d has been given to Set as NULL, then this tag is set to 0

Definition at line 214 of file IpStdAugSystemSolver.hpp.

double Ipopt::StdAugSystemSolver::delta_d_
| private

Most recent value of delta_d from Set method.

Definition at line 216 of file IpStdAugSystemSolver.hpp.

TaggedObject::Tag Ipopt::StdAugSystemSolver::augsys_tag_
| private

This is the tag of the matrix storing the augmented system.

Since this object owns this matrix, no changes should happen outside. However, since it is given away as a smart pointer, someone outside might change it. For debugging purposes, we now track its tag as well.

Definition at line 224 of file IpStdAugSystemSolver.hpp.

SmartPtr<CompoundSymMatrix> Ipopt::StdAugSystemSolver::augmented_system_
| private

The resulting augmented matrix.

This matrix is stored as follows: First we have the diagonal elements for the upper left block (for D_W and delta_W), then the elements for the Hessian W, then the Jacobian A, and finally the diagonal elements for the lower right block (for D_C and delta_C).

Definition at line 233 of file IpStdAugSystemSolver.hpp.

SmartPtr<const SymMatrix> Ipopt::StdAugSystemSolver::old_w_
| private

A copy of a previous W used in the augmented_system_.

Since Solve can be called with a NULL W, we keep a copy of the last W passed to keep the nonzero structure of the augmented_system_ consistent

Definition at line 238 of file IpStdAugSystemSolver.hpp.

bool Ipopt::StdAugSystemSolver::warm_start_same_structure_
| private

Flag indicating whether the TNLP with identical structure has already been solved before.

Definition at line 244 of file IpStdAugSystemSolver.hpp.

The documentation for this class was generated from the following file:

- src/Algorithm/IpStdAugSystemSolver.hpp